/*
 * Copyright 2022 MindMotion Microelectronics Co., Ltd.
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */


#ifndef __BOARD_INIT_H__
#define __BOARD_INIT_H__

#include <stdio.h>
#include <stdint.h>

#include "hal_common.h"
#include "hal_rcc.h"
#include "hal_uart.h"

#include "clock_init.h"
#include "pin_init.h"

#define BOARD_CLI_UART_PORT         UART1
#define BOARD_CLI_UART_BAUDRATE     9600u
#define BOARD_CLI_UART_FREQ         CLOCK_APB2_FREQ
#define BOARD_CLI_UART_IRQn         UART1_IRQn
#define BOARD_CLI_UART_IRQHandler   UART1_IRQHandler

/* LED. */
#define BOARD_LED_GPIO_PORT         GPIOI
#define BOARD_LED_GPIO_PIN          GPIO_PIN_0

void BOARD_Init(void);
void led_on(void);
void led_off(void);

#endif /* __BOARD_INIT_H__ */

