/*
 * Copyright 2022 MindMotion Microelectronics Co., Ltd.
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef __BOARD_INIT_H__
#define __BOARD_INIT_H__

#include <stdio.h>
#include <stdint.h>

#include "hal_common.h"
#include "hal_gpio.h"
#include "hal_uart.h"
#include "hal_rcc.h"

#include "clock_init.h"
#include "pin_init.h"

/* DEBUG UART. */
#define BOARD_DEBUG_UART_PORT        UART1
#define BOARD_DEBUG_UART_BAUDRATE    9600u
#define BOARD_DEBUG_UART_FREQ        CLOCK_APB2_FREQ

/* Pins. */
#define BOARD_SDSPI_TX_GPIO_PORT     GPIOC
#define BOARD_SDSPI_TX_GPIO_PIN      GPIO_PIN_12

#define BOARD_SDSPI_RX_GPIO_PORT     GPIOC
#define BOARD_SDSPI_RX_GPIO_PIN      GPIO_PIN_11

#define BOARD_SDSPI_CLK_GPIO_PORT    GPIOC
#define BOARD_SDSPI_CLK_GPIO_PIN     GPIO_PIN_10

#define BOARD_SDSPI_CS_GPIO_PORT     GPIOA
#define BOARD_SDSPI_CS_GPIO_PIN      GPIO_PIN_15

void BOARD_Init(void);

#endif /* __BOARD_INIT_H__ */
