/*
 * Copyright 2022 MindMotion Microelectronics Co., Ltd.
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */


#ifndef __BOARD_INIT_H__
#define __BOARD_INIT_H__

#include <stdio.h>
#include <stdint.h>

#include "hal_common.h"
#include "hal_rcc.h"
#include "hal_uart.h"
#include "hal_gpio.h"

#include "clock_init.h"
#include "pin_init.h"

/* DEBUG UART. */
#define BOARD_DEBUG_UART_PORT        UART1
#define BOARD_DEBUG_UART_BAUDRATE    9600u
#define BOARD_DEBUG_UART_FREQ        CLOCK_APB2_FREQ

/* LED0. */
#define BOARD_LED0_GPIO_PORT          GPIOI
#define BOARD_LED0_GPIO_PIN           GPIO_PIN_0

/* LED1. */
#define BOARD_LED1_GPIO_PORT          GPIOD
#define BOARD_LED1_GPIO_PIN           GPIO_PIN_2

void BOARD_Init(void);
void led0_onoff(bool onoff);
void led1_onoff(bool onoff);

#endif /* __BOARD_INIT_H__ */
