/* board_init.h */
#ifndef __BOARD_INIT_H__
#define __BOARD_INIT_H__

#include <stdio.h>
#include <stdint.h>

#include "hal_common.h"
#include "hal_rcc.h"
#include "hal_uart.h"
#include "hal_qspi.h"

#include "clock_init.h"
#include "pin_init.h"
#include "sfud.h"


/* DEBUG UART. */
#define BOARD_DEBUG_UART_PORT        UART1
#define BOARD_DEBUG_UART_BAUDRATE    9600u
#define BOARD_DEBUG_UART_FREQ        CLOCK_APB2_FREQ

#define BOARD_QSPI_PORT              QSPI
#define BOARD_QSPI_SCKDIV            4u
#define BOARD_QSPI_CS_HIGH_CYCLE     2u
#define BOARD_QSPI_RX_SAMPLE_DELAY   1u

void BOARD_Init(void);

#endif /* __BOARD_INIT_H__ */
