/*
 * Copyright 2022 MindMotion Microelectronics Co., Ltd.
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef __BOARD_INIT_H__
#define __BOARD_INIT_H__

#include <stdio.h>
#include <stdint.h>

#include "hal_common.h"
#include "hal_rcc.h"
#include "hal_uart.h"
#include "hal_fsmc.h"
#include "hal_gpio.h"

#include "clock_init.h"
#include "pin_init.h"

/* DEBUG UART. */
#define BOARD_DEBUG_UART_PORT        UART1
#define BOARD_DEBUG_UART_BAUDRATE    9600u
#define BOARD_DEBUG_UART_FREQ        CLOCK_APB2_FREQ

/* USB. */
#define BOARD_USB_PORT               USB
#define BOARD_USB_IRQn               USB_FS_IRQn
#define BOARD_USB_IRQHandler         USB_FS_IRQHandler
#define BOARD_USB_SOFTHRESHOLD       255u

#define BOARD_USB_VBUS_EN_GPIO_PORT  GPIOC
#define BOARD_USB_VBUS_EN_GPIO_PIN   GPIO_PIN_13

void BOARD_Init(void);
uint8_t board_getchar(void);



#endif /* __BOARD_INIT_H__ */
