/*
 * Copyright 2021 MindMotion Microelectronics Co., Ltd.
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef __BOARD_INIT_H__
#define __BOARD_INIT_H__

#include <stdio.h>

#include "hal_common.h"
#include "hal_gpio.h"
#include "hal_uart.h"

#include "clock_init.h"
#include "pin_init.h"

/* KEY0. */
#define BOARD_KEY0_GPIO_PORT GPIOB
#define BOARD_KEY0_GPIO_PIN  GPIO_PIN_15

/* LED0. */
#define BOARD_LED0_GPIO_PORT GPIOI
#define BOARD_LED0_GPIO_PIN  GPIO_PIN_0

/* LED1. */
#define BOARD_LED1_GPIO_PORT GPIOD
#define BOARD_LED1_GPIO_PIN  GPIO_PIN_2

/* DEBUG UART. */
#define BOARD_DEBUG_UART_PORT        UART1
#define BOARD_DEBUG_UART_BAUDRATE    9600u
#define BOARD_DEBUG_UART_FREQ        CLOCK_APB2_FREQ

void BOARD_Init(void);

#endif /* __BOARD_INIT_H__ */
