/*
 * Copyright 2022 MindMotion Microelectronics Co., Ltd.
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef __X25Q_CONF_H__
#define __X25Q_CONF_H__

#include "x25q.h"

/* list the index value of the device. */
enum
{
    X25Q_Device_W25Q64 = 0u, /* the W25Q64 device index. */
};

/* define the device table. */
#define X25Q_DEVICE_TABLE                               \
{                                                       \
    [X25Q_Device_W25Q64] =                              \
    {                                                   \
        .MemSize    = (8u * 1024u * 1024u), /* 8MB. */  \
        .SectorSize = 4096u,  /* 4K. */                 \
        .PageSize   = 256u,   /* 256 Byte. */           \
        .OperationMode = X25Q_OperationMode_QSPI,       \
    }, /* 8MB memory size, QPI mode. */                 \
}

#endif /* __X25Q_CONF_H__ */
